'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Carousel = (function (_Component) {
	_inherits(Carousel, _Component);

	function Carousel(props) {
		_classCallCheck(this, Carousel);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Carousel).call(this, props));

		_this.state = { slide: 1, dragging: null, sliding: false, offset: 0 }; // slide index start from 1
		_this.setTimer = _this.setTimer.bind(_this);
		return _this;
	}

	_createClass(Carousel, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.setTimer();
			this.refs.slider.addEventListener('transitionend', this.onTransitionEnd.bind(this), false);
		}
	}, {
		key: 'onTransitionEnd',
		value: function onTransitionEnd() {
			// this will not be triggered when document.hidden
			var slide = this.state.slide;

			var count = _react.Children.count(this.props.children);
			if (slide == count + 1) slide = 1;
			if (slide == 0) slide = count;
			this.setState({ slide: slide, sliding: false }, this.setTimer);
		}
	}, {
		key: 'setTimer',
		value: function setTimer() {
			var interval = this.props.autoplayInteval;
			if (interval && interval > 0) {
				window.clearInterval(this.timer);
				this.timer = window.setInterval(this.changeSlide.bind(this, this.state.slide + 1), interval);
			}
		}
	}, {
		key: 'changeSlide',
		value: function changeSlide(slide) {
			if (document.hidden) return; // run only when page is visible
			if (slide && slide >= 0 && slide <= _react2.default.Children.count(this.props.children) + 1) this.setState({ slide: slide, sliding: true, dragging: null }, this.setTimer);
		}
	}, {
		key: 'onDraggingStart',
		value: function onDraggingStart(event) {
			if (event.touches) this.setState({ dragging: {
					x: event.touches[0].pageX,
					y: event.touches[0].pageY
				}, offset: 0 });
		}
	}, {
		key: 'onDraggingMove',
		value: function onDraggingMove(event) {
			var _state = this.state;
			var sliding = _state.sliding;
			var dragging = _state.dragging;

			if (sliding || !dragging || !event.touches) return;
			var x = event.touches[0].pageX;
			var y = event.touches[0].pageY;
			var offset = x - dragging.x;
			if (Math.abs(y - dragging.y) < Math.abs(offset)) event.preventDefault();
			this.setState({ offset: offset });
		}
	}, {
		key: 'onDraggingEnd',
		value: function onDraggingEnd(event) {
			var _state2 = this.state;
			var slide = _state2.slide;
			var offset = _state2.offset;
			var dragging = _state2.dragging;

			if (!dragging) return;
			var target = Math.abs(offset) > this.refs.slider.clientWidth / 5 ? offset > 0 ? slide - 1 : slide + 1 : slide;
			this.setState({ dragging: null }, this.changeSlide.bind(this, target));
		}
	}, {
		key: 'onClick',
		value: function onClick(event) {
			if (Math.abs(this.state.offset) < 25) return; // trigger click in a small distance
			event.preventDefault();
			event.stopPropagation();
			event.nativeEvent.stopPropagation();
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props;
			var children = _props.children;
			var className = _props.className;
			var switcher = _props.switcher;
			var indicator = _props.indicator;
			var _state3 = this.state;
			var slide = _state3.slide;
			var sliding = _state3.sliding;
			var dragging = _state3.dragging;
			var offset = _state3.offset;

			var slides = _react.Children.map(children, function (child) {
				return _react2.default.cloneElement(child, { key: child.key + '_clone' });
			});
			var enabled = _react.Children.count(children) > 1;
			var prevSlide = this.changeSlide.bind(this, slide - 1);
			var nextSlide = this.changeSlide.bind(this, slide + 1);
			var events = {
				onTouchStart: this.onDraggingStart.bind(this),
				onTouchMove: this.onDraggingMove.bind(this),
				onTouchEnd: this.onDraggingEnd.bind(this),
				onTouchCancel: this.onDraggingEnd.bind(this),
				onClick: this.onClick.bind(this)
			};
			return _react2.default.createElement(
				'div',
				{ className: ['slider', className || ''].join(' '), style: {
						position: 'relative',
						overflowX: 'hidden',
						willChange: 'transform'
					} },
				_react2.default.createElement(
					'ul',
					_extends({ ref: 'slider', style: {
							display: 'flex',
							transform: dragging && offset !== 0 ? 'translateX(calc(' + offset * 1 + 'px - ' + slide * 100 + '%))' : 'translateX(-' + slide * 100 + '%)',
							transition: sliding ? 'transform .8s ease-in-out' : 'none'
						} }, events),
					enabled && _react.Children.map(slides.slice(-1).concat(children, slides.slice(0, 1)), function (item, index) {
						return _react2.default.createElement(
							'li',
							{ className: slide == index ? 'active' : null, style: {
									flexBasis: '100%',
									flexShrink: 0
								} },
							item
						);
					}) || _react2.default.createElement(
						'li',
						null,
						children
					)
				),
				enabled && switcher && _react2.default.createElement(
					'menu',
					null,
					_react2.default.createElement('button', { className: 'prev', onClick: prevSlide }),
					_react2.default.createElement('button', { className: 'next', onClick: nextSlide })
				),
				enabled && indicator && _react2.default.createElement(
					'ol',
					null,
					_react.Children.map(children, function (item, index) {
						return _react2.default.createElement(
							'li',
							{ className: slide == index + 1 ? 'active' : null },
							_react2.default.createElement(
								'button',
								{ onClick: _this2.changeSlide.bind(_this2, index + 1) },
								index
							)
						);
					})
				)
			);
		}
	}]);

	return Carousel;
})(_react.Component);

exports.default = Carousel;

